import Tool from "./tool";
import { saveGraphJson } from "../../../datasets";
import { SPACE } from "../../../config";
import SaveIcon from "../../images/tools/save.png";
import { Editor } from "../components/editor";

export default class SaveTool extends Tool {
    constructor(key) {
        super("Save", SaveIcon, key);
    }

    onToolActivate() {
        saveGraphJson(SPACE, Editor.globalGraph.serialize());
        Editor.globalGraph.saveChanges();
        Editor.globalState.setTool(Editor.globalState.previousTool);
        alert("Graph has been saved.");
    }
}
