import Tool from "./tool";
import * as SelectMenu from "./menus/selectmenu";
import SelectIcon from "../../images/tools/select.png";
import { Editor } from "../components/editor";

export default class SelectTool extends Tool {
    constructor(key) {
        super("Select", SelectIcon, key, new SelectMenu.SelectMenu());
    }

    onNodeClick(node) {
        Editor.globalState.setSelectedItem(node);
        this.menu.value(SelectMenu.SELECTION_KEY, node);
    }

    onLinkClick(link) {
        Editor.globalState.setSelectedItem(link);
        this.menu.value(SelectMenu.SELECTION_KEY, link);
    }

    onBackgroundClick(event, positions) {
        Editor.globalState.setSelectedItem(undefined);
        this.menu.value(SelectMenu.SELECTION_KEY, {});
    }

    onMenuChange(key, value) {
        if (key === SelectMenu.SELECTION_KEY) {
            Editor.globalGraph.changeDetails(value);
        }
    }

    onToolActivate() {
        if (Editor.globalState === undefined) {
            return;
        }

        var newSelection = Editor.globalState.selectedItem;
        if (newSelection === undefined) {
            newSelection = {};
        }

        this.menu.value(SelectMenu.SELECTION_KEY, newSelection);
    }
}
